"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getOperationNames = getOperationNames;
exports.findOperations = findOperations;
exports.getOperationForFixture = getOperationForFixture;
exports.validateFixture = validateFixture;
exports.AmbiguousOperationNameError = exports.MissingOperationError = void 0;

var _path = require("path");

var _graphql = require("graphql");

var _graphqlConfigUtilities = require("graphql-config-utilities");

var _CUSTOM_NAMES;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var MissingOperationError = /*#__PURE__*/function (_Error) {
  _inherits(MissingOperationError, _Error);

  var _super = _createSuper(MissingOperationError);

  function MissingOperationError(_ref, lookForOperationNames, projectASTCollection) {
    var path = _ref.path;

    _classCallCheck(this, MissingOperationError);

    return _super.call(this, ["Could not find a matching operation for '".concat(path, "'"), "(looked for ".concat(lookForOperationNames.join(', '), ")."), "Make sure to put your fixture in a folder named the same as the operation,", "or add an '".concat(OPERATION_MARKER, "' key indicating the operation."), "Available operations: ".concat(projectASTCollection.flatMap(function (_ref2) {
      var operations = _ref2.ast.operations;
      return Object.keys(operations);
    }).join(', '))].join(' '));
  }

  return MissingOperationError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

exports.MissingOperationError = MissingOperationError;

var AmbiguousOperationNameError = /*#__PURE__*/function (_Error2) {
  _inherits(AmbiguousOperationNameError, _Error2);

  var _super2 = _createSuper(AmbiguousOperationNameError);

  function AmbiguousOperationNameError(_ref3, foundOperations) {
    var path = _ref3.path;

    _classCallCheck(this, AmbiguousOperationNameError);

    return _super2.call(this, ["Ambiguous operation name found for '".concat(path, "'"), "(found ".concat(Array.from(new Set(foundOperations.map(function (_ref4) {
      var lookForOperationName = _ref4.lookForOperationName;
      return lookForOperationName;
    }))).join(', '), ")"), "in projects:", "".concat(foundOperations.map(function (_ref5) {
      var config = _ref5.projectAST.config;
      return (0, _graphqlConfigUtilities.resolveProjectName)(config);
    }).join(', '), "."), "Try renaming the operation in one of the projects listed and updating", "the fixture folder name or use an '".concat(OPERATION_MARKER, "' key indicating"), "the new operation name."].join(' '));
  }

  return AmbiguousOperationNameError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

exports.AmbiguousOperationNameError = AmbiguousOperationNameError;
var OPERATION_MARKER = '@operation';

function normalizeOperationName(operationName) {
  return operationName ? operationName.replace(/(Query|Mutation|Subscription)$/i, '') : undefined;
}

function getOperationNames(fixture) {
  var fixtureDirectoryName = (0, _path.basename)((0, _path.dirname)(fixture.path));
  var operationMarkerName = fixture.content[OPERATION_MARKER];
  return Array.from(new Set([fixtureDirectoryName, operationMarkerName, normalizeOperationName(fixtureDirectoryName), normalizeOperationName(operationMarkerName)])).filter(function (operationName) {
    return typeof operationName === 'string';
  });
}

function findOperations(lookForOperationNames, projectASTCollection) {
  return projectASTCollection.map(function (projectAST) {
    var _iterator = _createForOfIteratorHelper(lookForOperationNames),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var lookForOperationName = _step.value;
        var operation = projectAST.ast.operations[lookForOperationName];

        if (operation) {
          return {
            lookForOperationName: lookForOperationName,
            operation: operation,
            projectAST: projectAST
          };
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    return null;
  }).filter(function (match) {
    return Boolean(match);
  });
}

function getOperationForFixture(fixture, projectASTCollection) {
  var lookForOperationNames = getOperationNames(fixture);
  var operations = findOperations(lookForOperationNames, projectASTCollection);

  if (operations.length === 0) {
    throw new MissingOperationError(fixture, lookForOperationNames, projectASTCollection);
  }

  if (operations.length > 1) {
    throw new AmbiguousOperationNameError(fixture, operations);
  }

  return operations[0];
}

function validateFixture(fixture, ast, operation) {
  var _operation$fields = operation.fields,
      fields = _operation$fields === void 0 ? [] : _operation$fields,
      filePath = operation.filePath,
      operationType = operation.operationType;

  var value = _objectSpread({}, fixture.content);

  delete value[OPERATION_MARKER];
  return {
    fixturePath: fixture.path,
    operationName: operation.operationName,
    operationType: operationType,
    operationPath: filePath === 'GraphQL request' ? undefined : filePath,
    validationErrors: fields.reduce(function (allErrors, field) {
      return allErrors.concat(validateValueAgainstFieldDescription(value[field.responseName], field, '', ast));
    }, [])
  };
}

function validateValueAgainstFieldDescription(value, fieldDescription, parentKeyPath, ast) {
  var type = fieldDescription.type,
      responseName = fieldDescription.responseName;
  var keyPath = updateKeyPath(parentKeyPath, responseName);
  var typeErrors = validateValueAgainstType(value, type, keyPath, {
    shallow: true
  });

  if (typeErrors.length > 0) {
    return typeErrors;
  }

  return Array.isArray(value) ? validateListAgainstFieldDescription(value, fieldDescription, type, keyPath, ast) : validateValueAgainstObjectFieldDescription(value, fieldDescription, keyPath, ast);
}

function validateValueAgainstObjectFieldDescription(value, fieldDescription, keyPath, ast) {
  if (value == null || _typeof(value) !== 'object' || Array.isArray(value)) {
    return [];
  }

  var _fieldDescription$fie = fieldDescription.fields,
      fields = _fieldDescription$fie === void 0 ? [] : _fieldDescription$fie,
      _fieldDescription$fra = fieldDescription.fragmentSpreads,
      fragmentSpreads = _fieldDescription$fra === void 0 ? [] : _fieldDescription$fra,
      type = fieldDescription.type;
  var fragmentFields = [];

  if (fragmentSpreads) {
    fragmentSpreads.map(function (spread) {
      return ast.fragments[spread];
    }).forEach(function (fragment) {
      fragment.fields.forEach(function (field) {
        if (fields.some(function (_ref6) {
          var fieldName = _ref6.fieldName;
          return fieldName === field.fieldName;
        })) {
          return;
        }

        var isGuaranteedTypeMatch = fragment.possibleTypes.includes(makeTypeNullable(type));
        fragmentFields.push(isGuaranteedTypeMatch ? field : _objectSpread(_objectSpread({}, field), {}, {
          type: makeTypeNullable(field.type)
        }));
      });
    });
  }

  return validateValueAgainstFields(value, fields.concat(fragmentFields), keyPath, ast);
}

function makeTypeNullable(type) {
  return (0, _graphql.isNonNullType)(type) ? type.ofType : type;
}

function validateListAgainstFieldDescription(value, fieldDescription, type, keyPath, ast) {
  var itemType = (0, _graphql.isNonNullType)(type) ? type.ofType.ofType : type.ofType;
  return value.reduce(function (allErrors, item, index) {
    var itemKeyPath = updateKeyPath(keyPath, index);
    var itemTypeErrors = validateValueAgainstType(item, itemType, itemKeyPath, {
      shallow: true
    });

    if (itemTypeErrors.length > 0) {
      return allErrors.concat(itemTypeErrors);
    }

    return Array.isArray(item) ? allErrors.concat(validateListAgainstFieldDescription(item, fieldDescription, itemType, itemKeyPath, ast)) : allErrors.concat(validateValueAgainstObjectFieldDescription(item, fieldDescription, itemKeyPath, ast));
  }, []);
}

function validateValueAgainstFields(value, fields, keyPath, ast) {
  var finalValue = value || {};
  var excessFields = Object.keys(finalValue).filter(function (key) {
    return fields.every(function (_ref7) {
      var responseName = _ref7.responseName;
      return key !== responseName;
    });
  }).map(function (key) {
    return error(keyPath, "has key '".concat(key, "' not present in the query"));
  });
  return fields.reduce(function (allErrors, field) {
    return allErrors.concat(validateValueAgainstFieldDescription(finalValue[field.responseName], field, keyPath, ast));
  }, excessFields);
}

function validateValueAgainstType(value, type, keyPath) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {
    shallow: false
  };
  var shallow = options.shallow;

  if ((0, _graphql.isNonNullType)(type)) {
    return value == null ? [error(keyPath, "should be non-null but was ".concat(String(value)))] : validateValueAgainstType(value, type.ofType, keyPath, options);
  }

  if (value === null) {
    return [];
  }

  var valueType = _typeof(value);

  if ((0, _graphql.isListType)(type)) {
    if (!Array.isArray(value)) {
      return [error(keyPath, "should be an array (or null), but was ".concat(articleForType(valueType), " ").concat(valueType))];
    }

    return shallow ? [] : value.reduce(function (allErrors, item, index) {
      return allErrors.concat(validateValueAgainstType(item, type.ofType, updateKeyPath(keyPath, index), options));
    }, []);
  }

  if (value === undefined) {
    var typeName = nameForType(type);
    return [error(keyPath, "should be ".concat(articleForType(typeName), " ").concat(typeName, " (or null), but was undefined"))];
  }

  if ((0, _graphql.isObjectType)(type)) {
    if (valueType === 'object') {
      if (shallow) {
        return [];
      } else {
        var fields = type.getFields();
        return Object.keys(value).reduce(function (fieldErrors, key) {
          var fieldKeyPath = updateKeyPath(keyPath, key);
          return fields[key] == null ? fieldErrors.concat([error(fieldKeyPath, "does not exist on type ".concat(type.name, " (available fields: ").concat(Object.keys(fields).join(', '), ")"))]) : fieldErrors.concat(validateValueAgainstType(value[key], fields[key].type, fieldKeyPath, options));
        }, []);
      }
    } else {
      return [error(keyPath, "should be an object but was a ".concat(valueType))];
    }
  }

  if (type === _graphql.GraphQLString) {
    return valueType === 'string' ? [] : [error(keyPath, "should be a string but was a ".concat(valueType))];
  } else if (type === _graphql.GraphQLInt) {
    if (typeof value === 'number') {
      return Number.isInteger(value) ? [] : [error(keyPath, 'should be an integer but was a float')];
    }

    return [error(keyPath, "should be an integer but was a ".concat(valueType))];
  } else if (type === _graphql.GraphQLFloat) {
    return Number.isNaN(value) ? [error(keyPath, "should be a float but was a ".concat(valueType))] : [];
  } else if (type === _graphql.GraphQLBoolean) {
    return typeof value === 'boolean' ? [] : [error(keyPath, "should be a boolean but was a ".concat(valueType))];
  }

  if ((0, _graphql.isScalarType)(type)) {
    return type.parseValue(value) == null ? [error(keyPath, "value does not match scalar ".concat(nameForType(type)))] : [];
  }

  if ((0, _graphql.isEnumType)(type)) {
    return type.parseValue(value) == null ? [error(keyPath, "value does not match enum ".concat(nameForType(type), " (available values: ").concat(type.getValues().map(function (enumValue) {
      return enumValue.value;
    }).join(', '), ")"))] : [];
  }

  return [];
}

var CUSTOM_NAMES = (_CUSTOM_NAMES = {}, _defineProperty(_CUSTOM_NAMES, _graphql.GraphQLBoolean.name, 'boolean'), _defineProperty(_CUSTOM_NAMES, _graphql.GraphQLFloat.name, 'float'), _defineProperty(_CUSTOM_NAMES, _graphql.GraphQLInt.name, 'integer'), _defineProperty(_CUSTOM_NAMES, _graphql.GraphQLString.name, 'string'), _CUSTOM_NAMES);

function nameForType(type) {
  return Object.prototype.hasOwnProperty.call(CUSTOM_NAMES, type.name) ? CUSTOM_NAMES[type.name] : type.name;
}

var TYPES_WITH_ARTICLE_AN = ['object', 'integer', 'array'];

function articleForType(type) {
  return TYPES_WITH_ARTICLE_AN.includes(type) ? 'an' : 'a';
}

function updateKeyPath(keyPath, newKey) {
  if (typeof newKey === 'number') {
    return "".concat(keyPath, "[").concat(newKey, "]");
  }

  return keyPath ? "".concat(keyPath, ".").concat(newKey) : newKey;
}

function error(keyPath, message) {
  return {
    keyPath: keyPath,
    message: message
  };
}